import { getSignature } from '@/services/ant-design-pro/api';

// 生成文件名，作为 key 使用
const generateFileName = (ossData: any, fileName: any) => {
  const filename = Date.now() + fileName;
  return ossData.dir + filename;
};

const requestUpload = async (file: Blob, fileName: string) => {
  const result = await getSignature();
  const ossData = result.data;
  const key = generateFileName(ossData, fileName);
  const formData = new FormData(); // 注意参数的顺序，key 必须是第一位，表示OSS存储文件的路径

  formData.append('key', key);
  formData.append('OSSAccessKeyId', ossData.accessId);
  formData.append('policy', ossData.policy);
  formData.append('signature', ossData.signature); // 文件上传成功默认返回 204 状态码，可根据需要修改为 200
  formData.append('success_action_status', '200'); // file 必须放在最后一位
  formData.append('file', file as Blob);
  // const res = await upload(ossData.host, formData);
  const params = { method: 'POST', body: formData };
  const res = await fetch(ossData.host, params)
    .then((response) => response.json())
    .catch((error) => {
      console.error('Error:', error);
    });
  return ossData.host + '/' + key;
};

export { requestUpload };
